<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html, see LICENSE.php
 *
 * @module OpenSim Friends
 * @copyright Copyright (C) 2010 FoTo50 http://www.foto50.com/opensim/
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
//no direct access
defined('_JEXEC') or die('Direct Access to this location is not allowed.');


class mod_opensim_gridstatusInstallerScript {
	/**
	 * Constructor
	 *
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 */
	public function __constructor(JAdapterInstance $adapter) {
	}
 
	/**
	 * Called before any type of action
	 *
	 * @param   string  $route  Which action is happening (install|uninstall|discover_install)
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 *
	 * @return  boolean  True on success
	 */
	public function preflight($route, JAdapterInstance $adapter) {
		return TRUE;
	}
 
	/**
	 * Called after any type of action
	 *
	 * @param   string  $route  Which action is happening (install|uninstall|discover_install)
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 *
	 * @return  boolean  True on success
	 */
	public function postflight($route, JAdapterInstance $adapter) {
		return TRUE;
	}
 
	/**
	 * Called on installation
	 *
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 *
	 * @return  boolean  True on success
	 */
	public function install(JAdapterInstance $adapter) {
		$this->description();
		return TRUE;
	}
 
	/**
	 * Called on update
	 *
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 *
	 * @return  boolean  True on success
	 */
	public function update(JAdapterInstance $adapter) {
		$this->description();
		return TRUE;
	}
 
	/**
	 * Called on uninstallation
	 *
	 * @param   JAdapterInstance  $adapter  The object responsible for running this script
	 */
	public function uninstall(JAdapterInstance $adapter) {
		return TRUE;
	}

	public function description() {
		echo JText::_('JOPENSIM_GRIDSTATUS_INSTALL_MOD_DESC')."<br />\n";
		echo "<span style='color:#CC0000;'><strong>".JText::_('JOPENSIM_GRIDSTATUS_INSTALL_MOD_NEW').":</strong></span>\n";
		echo JText::_('JOPENSIM_FRIENDS_INSTALL_MOD_NEW_PARAM')."\n";
		
		// echo "<p>This module will show the status of your OpenSim grid.</p>\n";
		// echo "<p><span style='color:#ff0000;font-weight:bold;'>NEW:</span> You can now control if hidden regions will be counted or not for the value of &quot;total regions&quot;</p>\n";
	}
}
?>