<?php
/***********************************************************************

Class for OpenSimulator Joomla-Module

started 2010-08-30 by FoTo50 (Powerdesign) info@foto50.com

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

***********************************************************************/

class opensim {
	public static $version = "0.2.2 RCmin";
	// basic OpenSim database connection
	public $osdbhost;
	public $osdbuser;
	public $osdbpasswd;
	public $osdbname;
	public $osdbport;
	public $_os_db; // the object containing the connection to the external DB
	// OpenSim Grid database connection
	public $osgriddbhost;
	public $osgriddbuser;
	public $osgriddbpasswd;
	public $osgriddbname;
	public $osgriddbport;
	public $_osgrid_db; // the object containing the connection to the external (grid) DB
	// for the remoteAdmin connection
	private $remoteAdminHost;
	private $remoteAdminPort;
	private $remoteAdminPass;
	// define tables and fields here to avoid changing all over if something changes later
	public $userquery;
	public $defaultval = array();
	// table and fields for general info from user
	public $usertable						= "UserAccounts";
	public $usertable_field_id				= "PrincipalID";
	public $usertable_field_ScopeID			= "ScopeID";
	public $usertable_field_firstname		= "FirstName";
	public $usertable_field_lastname		= "LastName";
	public $usertable_field_email			= "Email";
	public $usertable_field_ServiceURLs		= "ServiceURLs";
	public $usertable_field_created			= "Created";
	public $usertable_field_UserLevel		= "UserLevel";
	public $usertable_field_UserFlags		= "UserFlags";
	public $usertable_field_UserTitle		= "UserTitle";
	// table and fields for info about user in the grid
	public $gridtable						= "GridUser";
	public $gridtable_field_id				= "UserID";
	public $gridtable_field_homeregion		= "HomeRegionID";
	public $gridtable_field_homeposition	= "HomePosition";
	public $gridtable_field_homelookat		= "HomeLookAt";
	public $gridtable_field_online			= "Online";
	public $gridtable_field_login			= "Login";
	public $gridtable_field_logout			= "Logout";
	// table and fields for user athentification
	public $authtable						= "auth";
	public $authtable_field_id				= "UUID";
	public $authtable_field_passwordHash	= "passwordHash";
	public $authtable_field_passwordSalt	= "passwordSalt";
	public $authtable_field_webLoginKey		= "webLoginKey";
	public $authtable_field_accountType		= "accountType";
	// table and fields for friends
	public $friendstable					= "Friends";
	public $friendstable_field_id			= "PrincipalID";
	public $friendstable_friend				= "Friend";
	public $friendstable_flags				= "Flags";
	public $friendstable_offered			= "Offered";
	// region table
	public $regiontable						= "regions";
	public $regiontable_field_id			= "uuid";
	public $regiontable_regionname			= "regionName";
	public $regiontable_serverIP			= "serverIP";
	public $regiontable_serverPort			= "serverPort";
	public $regiontable_locationX			= "locX";
	public $regiontable_locationY			= "locY";


	public function __construct($osdbhost,$osdbuser,$osdbpasswd,$osdbname,$osdbport = '3306',$osgriddbhost = '',$osgriddbuser = '',$osgriddbpasswd = '',$osgriddbname = '',$osgriddbport = '') {
		$this->osdbhost   = $osdbhost;
		$this->osdbuser   = $osdbuser;
		$this->osdbpasswd = $osdbpasswd;
		$this->osdbname   = $osdbname;
		$this->osdbport   = $osdbport;

		// if no grid connection is provided, assume that it is the same as the osdb
		$this->osgriddbhost   = ($osgriddbhost)   ? $osgriddbhost:$osdbhost;
		$this->osgriddbuser   = ($osgriddbuser)   ? $osgriddbuser:$osdbuser;
		$this->osgriddbpasswd = ($osgriddbpasswd) ? $osgriddbpasswd:$osdbpasswd;
		$this->osgriddbname   = ($osgriddbname)   ? $osgriddbname:$osdbname;
		$this->osgriddbport   = ($osgriddbport)   ? $osgriddbport:$osdbport;

		$this->connect2os();
		$this->connect2osgrid();
	}

	public function connect2os() {
		// check if another port is used
		if($this->osdbport && $this->osdbport != "3306") $externalhost = $this->osdbhost.":".$this->osdbport;
		else $externalhost = $this->osdbhost;

		$option['driver']   = 'mysql';				// Database driver name
		$option['host']     = $externalhost;		// Database host name and port
		$option['user']     = $this->osdbuser;		// User for database authentication
		$option['password'] = $this->osdbpasswd;	// Password for database authentication
		$option['database'] = $this->osdbname;		// Database name
		$option['prefix']   = '';					// Database prefix (may be empty)

		$os_db = & JDatabase::getInstance($option);

		if (JError::isError($os_db) || $os_db->getErrorNum() > 0) {
			return $this->externalDBerror();
		} else {
			$this->_os_db = $os_db;
//			$this->_os_db->setQuery("SET NAMES latin1");
//			$this->_os_db->query();
			return $this->_os_db;
		}
	}

	public function connect2osgrid() {
		// check if another port is used
		if($this->osgriddbport && $this->osgriddbport != "3306") $externalhost = $this->osgriddbhost.":".$this->osgriddbport;
		else $externalhost = $this->osgriddbhost;

		$option['driver']   = 'mysql';					// Database driver name
		$option['host']     = $externalhost;			// Database host name and port
		$option['user']     = $this->osgriddbuser;		// User for database authentication
		$option['password'] = $this->osgriddbpasswd;	// Password for database authentication
		$option['database'] = $this->osgriddbname;		// Database name
		$option['prefix']   = '';						// Database prefix (may be empty)

		$osgrid_db = & JDatabase::getInstance($option);
//		$this->debug[] = $osgrid_db;

		if (JError::isError($osgrid_db) || $osgrid_db->getErrorNum() > 0) {
			return $this->externalDBerror("OpenSim Grid DB");
		} else {
			$this->_osgrid_db = $osgrid_db;
//			$this->_os_db->setQuery("SET NAMES latin1");
//			$this->_os_db->query();
			return $this->_osgrid_db;
		}
	}

	public function externalDBerror() {
	//	JFactory::getApplication()->enqueueMessage(JText::_(ERROR_NOSIMDB),"error");
		return FALSE;
	}

	public function __destruct() {
	}
}
?>